package com.emsoft.groovy

import java.lang.annotation.ElementType
import java.lang.annotation.Retention
import java.lang.annotation.RetentionPolicy
import java.lang.annotation.Target
import org.codehaus.groovy.transform.GroovyASTTransformationClass

/**
 * User: Vladimir Zhukov
 *
 * @author Vladimir Zhukov
 *         Date: 21.01.11
 *         Time: 11:27
 */
@Retention(RetentionPolicy.SOURCE)
@Target(ElementType.FIELD)
@GroovyASTTransformationClass("com.emsoft.groovy.transform.PropertyASTTransformation")
@interface Property {

    Access getter() default Access.PUBLIC

    Access setter() default Access.PUBLIC

    boolean getterFinal() default false

    boolean setterFinal() default false

    boolean setterAllowNull() default true

    /**
     * If the field has no initial value then lazy initialization not genegated.
     * If the field is declared volatile and lazy is true then initialization will be synchronized using
     * the <a href="http://en.wikipedia.org/wiki/Double-checked_locking">double-checked locking</a> pattern.
     *
     * @return
     */
    boolean lazy() default false
}
